--region *.lua
--Date
--此文件由[BabeLua]插件自动生成
--网络消息lua层的派发管理
package.path = package.path .. ";src/?.lua"


local NetMgr = {}
i_msg_index = 1
cc.exports.MsgHandleTable = cc.exports.MsgHandleTable or {}

--注册消息handle
function NetMgr.Register(strCmdName,fun_MsgHandle,forceInsert)
    if strCmdName == nil or type(strCmdName) ~= "string" then
        print("[LUA ERROR]--NetMgr.Register--strCmdName is not string");
        return
    end

    --屏蔽麻将里面的推荐消息注册，因为特价金豆和付费返还重写了，原来的流程有问题
    if strCmdName == "RecommendGoodsNotify" or strCmdName == "MultiSpecialBeanNotify" then
        if forceInsert ~= true then
            print("[LUA ERROR]--NetMgr.Register--strCmdName is"..strCmdName.."  is not forceInsert");
            return
        end
    end

    if fun_MsgHandle == nil or type(fun_MsgHandle) ~= "function" then
        print("[LUA ERROR]--NetMgr.Register--fun_MsgHandle is not function");
        return
    end

    cc.exports.MsgHandleTable[strCmdName] = fun_MsgHandle
end

--取消注册handle
function NetMgr.UnRegister(strCmdName)
	local bFind = false
    for strCmd,funHandle in pairs(cc.exports.MsgHandleTable) do
        if strCmd == strCmdName then
            cc.exports.MsgHandleTable[strCmdName] = nil
			bFind = true
        end
    end
	
	if bFind == false then
		print("NetMgr.UnRegister--the strCmdName is not find! strCmdName=", strCmdName)
	end
end

--消息入口
function NetMgr.onMessage(strCmdName,msgData)
    local MemSelfMgr = false
    local PassDownFlag = 1

	print("NetMgr:onMessage--strCmdName=, msgData=", strCmdName, msgData)
    if strCmdName == nil then
        return 0,MemSelfMgr
    end
    
    for strCmd,funHandle in pairs(cc.exports.MsgHandleTable) do
        if strCmd == strCmdName then         
            MemSelfMgr,PassDownFlag = funHandle(strCmd,msgData)-- 返回true表示IDataX的内存自己管理
            MemSelfMgr = MemSelfMgr or false
            PassDownFlag = PassDownFlag or 1 --如果没有返回就默认1
            return PassDownFlag,MemSelfMgr
        end
    end

    print("NetMgr:onMessage--the strCmdName is not find! strCmdName=", strCmdName)
    return 0,MemSelfMgr
end

--网络消息入口参数DataXCmd
NetMgr_onMessage = function(msgData)
    local Ret,IsDetach = NetMgr.onMessage(msgData:get_cmd_name(),msgData:get_datax())
    if IsDetach == true then
        msgData:detach_datax(false)
    end
    return Ret
end

--网络消息入口参数IDataX
NetMgr_onMessageIDataX = function(strCmdName,IDataX)
    local Ret,IsDetach = NetMgr.onMessage(strCmdName,IDataX)
    if IsDetach == false then --因为这里传入的IDataX已经是需要手动释放，如果处理的地方没有缓存，在使用完成后直接释放
        ddz_delete(IDataX)
    end
    return Ret
end

--网络连接成功接口
NetMgr_NetConnected = function()
    print("NetMgr_NetConnected")
    local eventName = "GAME_NETCONNECTED"
    local event = cc.EventCustom:new(eventName)
    cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
    NotificationCenterPost(eventName)
end

return NetMgr
--endregion
