
-- 0 - disable debug info, 1 - less debug info, 2 - verbose debug info
DEBUG = 1

-- use framework, will disable all deprecated API, false - use legacy API
CC_USE_FRAMEWORK = true

-- show FPS on screen
CC_SHOW_FPS = true

-- disable create unexpected global variable
CC_DISABLE_GLOBAL = false

-- for module display
CC_DESIGN_RESOLUTION = {
    width = 1560,
    height = 720,
    autoscale = "FIXED_HEIGHT",    --SHOW_ALL,EXACT_FIT,FIXED_HEIGHT,FIXED_WIDTH
    callback = function(framesize)
        local ratio = framesize.width / framesize.height
        if ratio > 16/9 and ratio <= 20/9 then
            -- iPad 768*1024(1536*2048) is 4:3 screen
            return {autoscale = "FIXED_HEIGHT"}
        end
    end
}
